#!/bin/bash

set -e

cd "$(dirname "$0")"

inputPath=input
outputPath=output
mkdir $outputPath

function run
{
	frameworkName=$1
	frameworkPath=$2
	
	cp -R $inputPath/$frameworkName.framework $outputPath/
	
	binaryPathInternal=$frameworkName.framework/Versions/A/$frameworkName
	binaryPathInternalMoved=${binaryPathInternal}Original
	
	binaryPathLocal=$outputPath/$binaryPathInternal
	binaryPathLocalMoved=$outputPath/$binaryPathInternalMoved
	
	binaryPathFull=$frameworkPath/$binaryPathInternal
	binaryPathFullMoved=$frameworkPath/$binaryPathInternalMoved
	
	mv $binaryPathLocal $binaryPathLocalMoved
	
	wrapperName=${frameworkName}Wrapper
	
	clang++ $wrapperName.m -dynamiclib -o $wrapperName.o -framework CoreFoundation -framework Foundation -fmodules -Xlinker -reexport_library $binaryPathLocalMoved
	
	install_name_tool -change $binaryPathFull $binaryPathFullMoved $wrapperName.o	
	install_name_tool -id $binaryPathFull $wrapperName.o
	install_name_tool -id $binaryPathFullMoved $binaryPathLocalMoved
	
	mv $wrapperName.o $binaryPathLocal
	
	codesign -f -s - $binaryPathLocalMoved
	codesign -f -s - $binaryPathLocal
}

run "SkyLight" "/System/Library/PrivateFrameworks"
run "CoreDisplay" "/System/Library/Frameworks"
